# class XMLHttpRequest

#### package js.html

#### extends XMLHttpRequestEventTarget › EventTarget

Available on HTML5

`XMLHttpRequest` is an API that provides client functionality for transferring data between a client and a server. It provides an easy way to retrieve data from a URL without having to do a full page refresh. This enables a Web page to update just a part of the page without disrupting what the user is doing.

Documentation XMLHttpRequest by Mozilla Contributors, licensed under CC-BY-SA 2.5.

See:

https://developer.mozilla.org/en-US/docs/Web/API/XMLHttpRequest

### Constructor

###

`new (ignored:String)`

`new (?params:Dynamic)`

Throws:

`null` | DOMError

### Variables

###

`onreadystatechange:Function`

###

`read onlyreadyState:Int`

###

`read onlyresponse:Dynamic`

Returns an `ArrayBuffer`, `Blob`, `Document`, JavaScript object, or a `DOMString`, depending on the value of `XMLHttpRequest.responseType`. that contains the response entity body.

###

`read onlyresponseText:String`

###

`responseType:XMLHttpRequestResponseType`

###

`read onlyresponseURL:String`

###

`read onlyresponseXML:HTMLDocument`

###

`read onlystatus:Int`

###

`read onlystatusText:String`

###

`timeout:Int`

###

`read onlyupload:XMLHttpRequestUpload`

###

`withCredentials:Bool`

### Methods

###

`abort ():Void`

Throws:

`null` | DOMError

###

`getAllResponseHeaders ():String`

Throws:

`null` | DOMError

###

`getResponseHeader (header:String):String`

Throws:

`null` | DOMError

###

`open (method:String, url:String, async:Bool, ?user:String, ?password:String):Void`

`open (method:String, url:String):Void`

Throws:

`null` | DOMError

###

`overrideMimeType (mime:String):Void`

Throws:

`null` | DOMError

###

`send (data:Dynamic):Void`

`send ():Void`

`send (data:ArrayBuffer):Void`

`send (data:ArrayBufferView):Void`

`send (data:Blob):Void`

`send (data:HTMLDocument):Void`

`send (data:String):Void`

`send (data:FormData):Void`

Throws:

`null` | DOMError

###

`setRequestHeader (header:String, value:String):Void`

Throws:

`null` | DOMError

### Static variables

###

`staticinline read onlyDONE:Int = 4`

###

`staticinline read onlyHEADERS_RECEIVED:Int = 2`

###

`staticinline read onlyLOADING:Int = 3`

###

`staticinline read onlyOPENED:Int = 1`

###

`staticinline read onlyUNSENT:Int = 0`

### Inherited Variables

#### Defined by XMLHttpRequestEventTarget

###

`onabort:Function`

###

`onerror:Function`

###

`onload:Function`

###

`onloadend:Function`

###

`onloadstart:Function`

###

`onprogress:Function`

###

`ontimeout:Function`

### Inherited Methods

#### Defined by EventTarget

###

`addEventListener (type:String, listener:Function, capture:Bool = false):Void`

`addEventListener (type:String, listener:EventListener, capture:Bool = false, ?wantsUntrusted:Bool):Void`

Throws:

`null` | DOMError

###

`dispatchEvent (event:Event):Bool`

Throws:

`null` | DOMError

###

`removeEventListener (type:String, listener:Function, capture:Bool = false):Void`

`removeEventListener (type:String, listener:EventListener, capture:Bool = false):Void`

Throws:

`null` | DOMError